\( \newcommand{\E}{\mathrm{E}} \) \( \newcommand{\A}{\mathrm{A}} \) \( \newcommand{\R}{\mathrm{R}} \) \( \newcommand{\N}{\mathrm{N}} \) \( \newcommand{\Q}{\mathrm{Q}} \) \( \newcommand{\Z}{\mathrm{Z}} \) \( \def\ccSum #1#2#3{ \sum_{#1}^{#2}{#3} } \def\ccProd #1#2#3{ \sum_{#1}^{#2}{#3} }\)

CGAL 4.8 - 3D Fast Intersection and Distance Computation (AABB Tree)

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Groups Pages
List of all members | Public Member Functions
CGAL::AABB_primitive< Id, ObjectPropertyMap, PointPropertyMap, ExternalPropertyMaps, CacheDatum > Struct Template Reference
AABB Tree Reference

`#include <CGAL/AABB_primitive.h>`

## Definition

Generic primitive type.

The two property maps which are template parameters of the class enable to get the datum and the reference point of the primitive from the identifier. The last template parameter controls whether the primitive class holds a copy of the datum.

Is Model Of:
  `AABBPrimitive` if `ExternalPropertyMaps` is `CGAL::Tag_false`, and `AABBPrimitiveWithSharedData` if `ExternalPropertyMaps` is `CGAL::Tag_true`.

Template Parameters

  ObjectPropertyMap | is a model of `ReadablePropertyMap` with `Id` as `key_type`. It must be default constructible.
  PointPropertyMap | is a model of `ReadablePropertyMap` with `Id` as `key_type`. It must be default constructible.
  ExternalPropertyMaps | either `CGAL::Tag_true` or `CGAL::Tag_false`. In the former case, the property maps will be stored in the traits class, while in the latter they will be stored in the primitive (which increases the size of each primitive).
  CacheDatum | either `CGAL::Tag_true` or `CGAL::Tag_false`. In the former case, the datum is stored in the primitive, while in the latter it is constructed on the fly to reduce the memory footprint. The default is `CGAL::Tag_false` (datum is not stored).

See Also
  `AABBPrimitive`
  `AABB_segment_primitive<Iterator,CacheDatum>`
  `AABB_triangle_primitive<Iterator,CacheDatum>`
  `AABB_halfedge_graph_segment_primitive<HalfedgeGraph,OneHalfedgeGraphPerTree,CacheDatum>`
  `AABB_face_graph_triangle_primitive<FaceGraph,OneFaceGraphPerTree,CacheDatum>`

## Public Member Functions
| AABB_primitive (Id id, ObjectPropertyMap o_pmap=ObjectPropertyMap(), PointPropertyMap p_pmap=PointPropertyMap())
| Constructs a primitive and initializes the property maps.

## Types
typedef boost::property_traits < ObjectPropertyMap > ::value_type | Datum
| The datum type.
typedef boost::property_traits < PointPropertyMap > ::value_type | Point
| The point type.
typedef boost::property_traits < ObjectPropertyMap > ::reference | Datum_reference
| The reference datum type.
typedef boost::property_traits < PointPropertyMap > ::reference | Point_reference
| The reference point type.
typedef Id | Id
| Id type.